## mingw-w64-tfel-4.2.0-2.src.tar.zst

=== CMakeLists.txt ===
# Remove when CMake >= 2.8.4 is required
set(CMAKE_LEGACY_CYGWIN_WIN32 0) 
cmake_minimum_required(VERSION 2.4)
cmake_policy(SET CMP0005 OLD)
if(CMAKE_VERSION VERSION_GREATER 3.0.0)
  cmake_policy(SET CMP0026 OLD)
endif(CMAKE_VERSION VERSION_GREATER 3.0.0)
if(CMAKE_VERSION VERSION_GREATER 3.1.0)
  cmake_policy(SET CMP0053 OLD)
  cmake_policy(SET CMP0054 NEW)
endif(CMAKE_VERSION VERSION_GREATER 3.1.0)

set(TFEL_VERSION_FLAVOUR "" CACHE STRING
  "Append a flavour to the version number")
option(TFEL_APPEND_VERSION
  "append TFEL version number to all libraries, executables and directories" OFF)
option(BUILD_SHARED_LIBS  "enable shared libraries" ON)
if(NOT BUILD_SHARED_LIBS)
  set(CMAKE_POSITION_INDEPENDENT_CODE ON)
  # when BUILD_SHARED_LIBS=OFF then disable option enable-static
  set(enable-static OFF CACHE BOOL "enable additional static libraries" FORCE)
endif()

if(EXISTS "${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")
  include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
  conan_basic_setup(NO_OUTPUT_DIRS)
  set(TFEL_USES_CONAN ON)
endif(EXISTS "${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")

set(CMAKE_CXX_STANDARD 17)
set(CXX_STANDARD_REQUIRED ON)

# tfel specific macros
include(cmake/modules/tfel.cmake)
# some variables for compatibility with autotools
include(cmake/modules/autotools.cmake)

#major and minor version
tfel_project(4 2 "0")
set(PACKAGE_BUGREPORT "tfel-contact@cea.fr")

# load the list of rounding modes defined by the IEEE754 standard
include(cmake/modules/ieee754.cmake)

# check for the fenv package
include(CheckIncludeFiles)
check_include_files(fenv.h HAVE_FENV_H)
if(HAVE_FENV_H)
  add_definitions("-DHAVE_FENV")
endif(HAVE_FENV_H)

option(enable-include-what-you-use
  "enable include-what-you-use diagnostics" OFF)
if(enable-include-what-you-use)
  find_program(TFEL_IWYU_PATH NAMES include-what-you-use iwyu)
  if(NOT TFEL_IWYU_PATH)
    message(FATAL_ERROR "could not find the program include-what-you-use")
  endif()
endif(enable-include-what-you-use)

find_package(Threads)

if(UNIX)
  if(NOT TFEL_DL_LIBRARY)
    # This is used in mtest tests files
    set(TFEL_LOCAL_LIBRARY_PREFIX "./")
    # Looking for libdl...
    if((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
	(${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
      find_library(TFEL_DL_LIBRARY
	NAMES dl)
      if(NOT TFEL_DL_LIBRARY)
	MESSAGE(FATAL_ERROR "the libdl library not found. You may want to set the `TFEL_DL_LIBRARY` manually")
      endif(NOT TFEL_DL_LIBRARY)
    else((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
	(${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
      set(TFEL_DL_LIBRARY "")
    endif((${CMAKE_SYSTEM_NAME} MATCHES "Linux") OR
      (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
  endif(NOT TFEL_DL_LIBRARY)
else(UNIX)
  set(TFEL_LOCAL_LIBRARY_PREFIX "")
  set(TFEL_DL_LIBRARY "")
endif(UNIX)

# adding support for rpath on MacOs X
if(APPLE)
   set(CMAKE_MACOSX_RPATH ON)
   set(CMAKE_SKIP_BUILD_RPATH FALSE)
   set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
   set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
   set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
   list(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
   if("${isSystemDir}" STREQUAL "-1")
      set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
   endif()
endif()

# type of architecture
if( CMAKE_SIZEOF_VOID_P EQUAL 8 )
  add_definitions("-DTFEL_ARCH64")
else( CMAKE_SIZEOF_VOID_P EQUAL 8 )
  add_definitions("-DTFEL_ARCH32")
endif( CMAKE_SIZEOF_VOID_P EQUAL 8 )

#extraction svn revision
if(NOT TFEL_SVN_REVISION)
execute_process(COMMAND svnversion
                WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}"
                OUTPUT_VARIABLE TFEL_SVN_REVISION 
		OUTPUT_STRIP_TRAILING_WHITESPACE)
endif(NOT TFEL_SVN_REVISION)
add_definitions("-DTFEL_SVN_REVISION=\\\"\"${TFEL_SVN_REVISION}\"\\\"")
add_definitions("-DTFEL_CMAKE_GENERATOR=\\\"\"${CMAKE_GENERATOR}\"\\\"")

# testing
set(CTEST_CONFIGURATION_TYPE "${JOB_BUILD_CONFIGURATION}")
# (must be placed *before* any add_subdirectory, cmake bug ?)
option(enable-testing "enable tests" ON)
option(enable-mfront-quantity-tests "enable tests of behaviours using quantities (such tests fails on old compilers)" ON)
if(enable-testing)
  enable_testing()
  if(CMAKE_CONFIGURATION_TYPES)
    add_custom_target(check COMMAND
      ${CMAKE_CTEST_COMMAND} -T test -C $<CONFIGURATION>)
  else(CMAKE_CONFIGURATION_TYPES)
    add_custom_target(check COMMAND
      ${CMAKE_CTEST_COMMAND} -T test )
  endif(CMAKE_CONFIGURATION_TYPES)
endif()

option(enable-cppcheck "analyse targets with cppcheck" OFF)
if(enable-cppcheck)
  message(STATUS "cppcheck support enabled")
  set(HAVE_CPPCHECK ON)
  include(cmake/modules/FindCppCheck.cmake)
  include(cmake/modules/CppCheckTargets.cmake)
endif(enable-cppcheck)

option(enable-vera++ "analyse targets with vera++" OFF)
if(enable-vera++)
  message(STATUS "vera++ support enabled")
  find_package(vera++)
  include(${VERA++_USE_FILE})
  if(NOT VERA_ROOT)
    message(fatal "VERA_ROOT is not defined")
  endif(NOT VERA_ROOT)
  add_vera_targets(*.h *.cpp
    RECURSE
    ROOT "${VERA_ROOT}/lib/vera++")
endif(enable-vera++)

# floatting point exceptions (TODO)

# portable-build
option(enable-portable-build "produce binary that can be shared between various machine (same architecture, same gcc version, different processors" OFF)

# madnex
option(enable-madnex "enable madnex file support in mfront (see https://github.com/thelfer/madnex)" OFF)
if(enable-madnex)
  find_package(Madnex REQUIRED)
  set(TFEL_HAVE_MADNEX ON)
endif(enable-madnex)

# fortran (placed before compiler detection)
option(enable-fortran "enable fortran support" OFF)
if(enable-fortran)
  set(HAVE_FORTRAN ON)
  add_definitions("-DHAVE_FORTRAN=1")
  enable_language (Fortran)
  message(STATUS "fortran support enabled")
  set(enable-fortran-bindings ON)
else(enable-fortran)
  set(HAVE_FORTRAN OFF)
  message(STATUS "fortran support disabled")
  set(enable-fortran-bindings OFF)
endif(enable-fortran)

#compiler options
include(cmake/modules/compiler.cmake)
if(CMAKE_BUILD_TYPE STREQUAL "Coverage")
  include(cmake/modules/CodeCoverage.cmake)
  SETUP_TARGET_FOR_COVERAGE(coverage ctest coverage)
endif(CMAKE_BUILD_TYPE STREQUAL "Coverage")

#aster
option(enable-aster "build aster interface for mechanical behaviours" OFF)
if(enable-aster)
  message(STATUS "aster support enabled")
  set(HAVE_ASTER ON)
  add_definitions("-DHAVE_ASTER=1")
  include(cmake/modules/aster.cmake)
endif(enable-aster)

#abaqus
option(enable-abaqus "build abaqus interface for mechanical behaviours" OFF)
if(enable-abaqus)
  message(STATUS "abaqus support enabled")
  set(HAVE_ABAQUS ON)
  add_definitions("-DHAVE_ABAQUS=1")
endif(enable-abaqus)

# LS-DYNA
option(enable-lsdyna "build lsdyna interface for mechanical behaviours" OFF)
if(enable-lsdyna)
  message(STATUS "lsdyna support enabled")
  set(HAVE_LSDYNA ON)
  add_definitions("-DHAVE_LSDYNA=1")
endif(enable-lsdyna)

#diana-fea
option(enable-diana-fea "build Diana FEA interface for mechanical behaviours" OFF)
if(enable-diana-fea)
  message(STATUS "Diana FEA support enabled")
  set(HAVE_DIANAFEA ON)
  add_definitions("-DHAVE_DIANAFEA=1")
endif(enable-diana-fea)

#calculix
option(enable-calculix "build CalculiX interface for mechanical behaviours" OFF)
if(enable-calculix)
  message(STATUS "CalculiX support enabled")
  set(HAVE_CALCULIX ON)
  add_definitions("-DHAVE_CALCULIX=1")
endif(enable-calculix)

#ansys
option(enable-ansys "build ansys interface for mechanical behaviours" OFF)
if(enable-ansys)
  message(STATUS "ansys support enabled")
  set(HAVE_ANSYS ON)
  add_definitions("-DHAVE_ANSYS=1")
endif(enable-ansys)

#europlexus
option(enable-europlexus "build europlexus interface for mechanical behaviours" OFF)
if(enable-europlexus)
  message(STATUS "europlexus support enabled")
  set(HAVE_EUROPLEXUS ON)
  add_definitions("-DHAVE_EUROPLEXUS=1")
endif(enable-europlexus)

#zmat
option(enable-zmat "build zmat interface for mechanical behaviours" OFF)
if(enable-zmat)
  include(cmake/modules/zset.cmake)
  message(STATUS "zmat support enabled")
  set(HAVE_ZMAT ON)
  add_definitions("-DHAVE_ZMAT=1")
endif(enable-zmat)

#cyrano
include(cmake/modules/cyrano.cmake)
option(enable-cyrano "build cyrano interface for mechanical behaviours" OFF)
if(enable-cyrano)
  message(STATUS "cyrano support enabled")
  set(HAVE_CYRANO ON)
  add_definitions("-DHAVE_CYRANO=1")
endif(enable-cyrano)

#castem
include(cmake/modules/castem-unix-type.cmake)
option(local-castem-header    "use a local version of castem.h"  OFF)
option(enable-castem-pleiades "use a pleiades version of castem" OFF)
if(local-castem-header)
  add_definitions(-DLOCAL_CASTEM_HEADER=1)
  add_definitions("-DLOCAL_CASTEM_HEADER=1 -DHAVE_CASTEM=1")
  set(HAVE_CASTEM ON)
  set(LOCAL_CASTEM_HEADER ON)
else(local-castem-header)
  include(cmake/modules/castem.cmake)
endif(local-castem-header)

# comsol
option(enable-comsol "build Comsol interface for mechanical behaviours" OFF)
if(enable-comsol)
  message(STATUS "Comsol support enabled")
  set(HAVE_COMSOL ON)
  add_definitions("-DHAVE_COMSOL=1")
endif(enable-comsol)

#gnuplot
include(FindGnuplot)
if(GNUPLOT_FOUND)
  set(HAVE_GNUPLOT ON)
  add_definitions("-DHAVE_GNUPLOT=1")
  add_definitions("-DGNUPLOT_PATH=\\\"\"${GNUPLOT_EXECUTABLE}\"\\\"")
  message(STATUS "found gnuplot")
  message(STATUS "gnuplot path ${GNUPLOT_EXECUTABLE}")
else(GNUPLOT_FOUND)
  set(HAVE_GNUPLOT OFF)
endif(GNUPLOT_FOUND)

#python
option(enable-python "enable python support" OFF)
option(enable-python-bindings "enable  python bindings support" OFF)
option(enable-numpy-support
  "enable numpy support. This option has no effect if python bindings are disabled" ON)
option(enable-broken-boost-python-module-visibility-handling
  "workaround a bug in boost python which occurs on FreeBSD+clang. See https://github.com/boostorg/python/issues/173 for details" OFF)

option(python-static-interpreter-workaround
  "a workaround to handle the fact the conda' python interpreter is statically linked, which causes issues on Mac Os. See for details https://github.com/ContinuumIO/anaconda-issues/issues/9078. A proper solution may only appear with CMake 3.15 with the `Python::module` target, see https://gitlab.kitware.com/cmake/cmake/issues/18100. Until this version is widely available, this flag proposes a hack. Use with care." OFF)
 
if(enable-python OR enable-python-bindings)
  find_package(PythonLibs REQUIRED)
  set(HAVE_PYTHON ON)
  add_definitions("-DHAVE_PYTHON=1")
  add_definitions("-DTFEL_PYTHON_INCLUDES=\\\"\"-I${PYTHON_INCLUDE_DIRS}\"\\\"")
  get_filename_component(PYTHON_LIBRARY_PATH ${PYTHON_LIBRARIES} PATH)
  get_filename_component(PYTHON_LIBRARY_FULL ${PYTHON_LIBRARIES} NAME)
  string(REGEX REPLACE "lib(.+)\\.(.+)$" "\\1" PYTHON_LIBRARY ${PYTHON_LIBRARY_FULL})
  add_definitions("-DTFEL_PYTHON_LIBRARY_PATH=\\\"\"${PYTHON_LIBRARY_PATH}\"\\\"")
  add_definitions("-DTFEL_PYTHON_LIBRARY=\\\"\"${PYTHON_LIBRARY}\"\\\"")
  if(MSVC)
    add_definitions("-DTFEL_PYTHON_LIBS=\\\"\"${PYTHON_LIBRARY_PATH}\${PYTHON_LIBRARY}\"\\\"")
  else(MSVC)
    add_definitions("-DTFEL_PYTHON_LIBS=\\\"\"-L${PYTHON_LIBRARY_PATH} -l${PYTHON_LIBRARY}\"\\\"")
  endif(MSVC) 
  message(STATUS "found python          ${PYTHONLIBS_VERSION_STRING}")
  message(STATUS "python include path   ${PYTHON_INCLUDE_DIRS}")
  message(STATUS "python libraries path ${PYTHON_LIBRARY_PATH}")
  message(STATUS "python library        ${PYTHON_LIBRARY}")
  string(REGEX REPLACE "[a-z]+.*$" "" PYTHONLIBS_VERSION_CLEANED "${PYTHONLIBS_VERSION_STRING}")
  find_package(PythonInterp ${PYTHONLIBS_VERSION_CLEANED} REQUIRED)
  message(STATUS "python interpreter    ${PYTHON_EXECUTABLE}")
  if(enable-numpy-support AND PYTHON_EXECUTABLE AND (NOT NUMPY_INCLUDE_DIRS))
    execute_process(
      COMMAND "${PYTHON_EXECUTABLE}" -c
              "from __future__ import print_function\ntry: import numpy; print(numpy.get_include(), end='')\nexcept:pass\n"
              OUTPUT_VARIABLE NUMPY_INCLUDE_PATH)

=== bindings/CMakeLists.txt ===
if(enable-python-bindings)
  add_subdirectory(python)
endif(enable-python-bindings)

if(enable-fortran-bindings)
  add_subdirectory(fortran77)
  add_subdirectory(fortran90)
endif(enable-fortran-bindings)

=== mfm/CMakeLists.txt ===
add_subdirectory(src)
if(enable-testing)
  add_subdirectory(tests)
endif()

=== bindings/fortran90/CMakeLists.txt ===
add_library(TFELPhysicalConstantsFortran90Bindings tfel_physical_constants.f90)
set_target_properties(TFELPhysicalConstantsFortran90Bindings
  PROPERTIES Fortran_MODULE_DIRECTORY "TFEL")
if(TFEL_APPEND_SUFFIX)  
  install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/TFEL"
    DESTINATION "include/TFEL-${TFEL_SUFFIX}"
    COMPONENT core)
else(TFEL_APPEND_SUFFIX)
  install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/TFEL"
    DESTINATION "include"
    COMPONENT core)
endif(TFEL_APPEND_SUFFIX)

=== docs/mfront/CMakeLists.txt ===
macro(install_mfront_desc file)
  # if(HAVE_PANDOC)
  #   ADD_CUSTOM_COMMAND(
  #     OUTPUT    ${file}.html
  #     DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/${file}.md
  #     DEPENDS   ${PROJECT_SOURCE_DIR}/docs/web/mfront-template.html
  #     DEPENDS   ${PROJECT_SOURCE_DIR}/docs/web/css/main.css
  #     COMMAND   ${PANDOC}
  #     ARGS      -f markdown-markdown_in_html_blocks+tex_math_single_backslash
  #     ARGS      --mathjax
  #     ARGS      ${ARGN}
  #     ARGS      ${CMAKE_CURRENT_SOURCE_DIR}/${file}.md -o ${file}.html)
  #   add_custom_target(mfront-${file}-html ALL DEPENDS ${file}.html)
  #   add_dependencies(website mfront-${file}-html)
  #   install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${file}.html
  #     DESTINATION share/doc/tfel/web/mfront
  #     COMPONENT website)
  # endif(HAVE_PANDOC)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${file}.md
      DESTINATION share/doc/mfront-${TFEL_SUFFIX}
      COMPONENT mfront)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${file}.md DESTINATION share/doc/mfront
      COMPONENT mfront)
  endif(TFEL_APPEND_SUFFIX)
endmacro(install_mfront_desc file)

macro(install_mfront_desc2 directory file)
  # if(HAVE_PANDOC)
  #   ADD_CUSTOM_COMMAND(
  #     OUTPUT    ${file}-${directory}.html
  #     DEPENDS   ${CMAKE_CURRENT_SOURCE_DIR}/${directory}/${file}.md
  #     COMMAND   ${PANDOC}
  #     ARGS      -f markdown-markdown_in_html_blocks+tex_math_single_backslash
  #     ARGS      --mathjax
  #     ARGS      ${ARGN}
  #     ARGS      ${CMAKE_CURRENT_SOURCE_DIR}/${directory}/${file}.md -o ${file}-${directory}.html)
  # add_custom_target(mfront-${file}-${directory}-html ALL DEPENDS ${file}-${directory}.html)
  # add_dependencies(website mfront-${file}-${directory}-html)
  #   install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${file}-${directory}.html
  #     DESTINATION share/doc/tfel/web/mfront/${directory}/${file}.html
  #     COMPONENT website)
  # endif(HAVE_PANDOC)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${directory}/${file}.md
      DESTINATION share/doc/mfront-${TFEL_SUFFIX}/${directory}
      COMPONENT mfront)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${directory}/${file}.md
      DESTINATION share/doc/mfront/${directory}
      COMPONENT mfront)
  endif(TFEL_APPEND_SUFFIX)
endmacro(install_mfront_desc2 directory file)

install_mfront_desc(AdditionalConvergenceChecks)
install_mfront_desc(AdditionalTangentOperatorBlock)
install_mfront_desc(AdditionalTangentOperatorBlocks)
install_mfront_desc(Algorithm)
install_mfront_desc(Author)
install_mfront_desc(AuxiliaryStateVar)
install_mfront_desc(AuxiliaryStateVariable)
install_mfront_desc(AxialGrowth)
install_mfront_desc(Behaviour)
install_mfront_desc(Bounds)
install_mfront_desc(Brick)
install_mfront_desc(Coef)
install_mfront_desc(ComputeFinalStress)
install_mfront_desc(ComputeStiffnessTensor)
install_mfront_desc(ComputeStressFreeExpansion)
install_mfront_desc(ComputeStress)
install_mfront_desc(ComputeThermalExpansion)
install_mfront_desc(CompareToNumericalJacobian)
install_mfront_desc(CrystalStructure)
install_mfront_desc(Date)
install_mfront_desc(Description)
install_mfront_desc(DislocationsMeanFreePathInteractionMatrix)
install_mfront_desc(DissipatedEnergy)
install_mfront_desc(DSL)
install_mfront_desc(ElasticMaterialProperties)
install_mfront_desc(Epsilon)
install_mfront_desc(ExternalStateVar)
install_mfront_desc(ExternalStateVariable)
install_mfront_desc(GlidingSystem)
install_mfront_desc(GlidingSystems)
install_mfront_desc(Import)
install_mfront_desc(InitializeJacobian)
install_mfront_desc(InitializeJacobianInvert)
install_mfront_desc(InitJacobian)
install_mfront_desc(InitJacobianInvert)
install_mfront_desc(Includes)
install_mfront_desc(InteractionMatrix)
install_mfront_desc(IntegrationVariable)
install_mfront_desc(Interface)
install_mfront_desc(InternalEnergy)
install_mfront_desc(InitLocalVars)
install_mfront_desc(InitLocalVariables)
install_mfront_desc(InitializeLocalVariables)
install_mfront_desc(InitializeFunction)
install_mfront_desc(InitializeFunctionVariable)
install_mfront_desc(IsotropicBehaviour)
install_mfront_desc(IsotropicElasticBehaviour)
install_mfront_desc(IterMax)
install_mfront_desc(JacobianComparisonCriterion)
install_mfront_desc(JacobianComparisonCriterium)
install_mfront_desc(Library)
install_mfront_desc(Link)
install_mfront_desc(LocalVar)
install_mfront_desc(Material)
install_mfront_desc(MaterialLaw)
install_mfront_desc(MaterialProperty)
install_mfront_desc(MaximumNumberOfIterations)
install_mfront_desc(MaximalTimeStepScalingFactor)
install_mfront_desc(MinimalTimeStepScalingFactor)
install_mfront_desc(Model)
install_mfront_desc(NumericallyComputedJacobianBlocks)
install_mfront_desc(OrthotropicBehaviour)
install_mfront_desc(Parameter)
install_mfront_desc(Parser)
install_mfront_desc(PerturbationValueForNumericalJacobianComputation)
install_mfront_desc(PhysicalBounds)
install_mfront_desc(PostProcessing)
install_mfront_desc(PostProcessingVariable)
install_mfront_desc(ProcessNewCorrection)
install_mfront_desc(ProcessNewEstimate)
install_mfront_desc(Private)
install_mfront_desc(Profiling)
install_mfront_desc(Relocation)
install_mfront_desc(RejectCurrentCorrection)
install_mfront_desc(RequireStiffnessOperator)
install_mfront_desc(RequireStiffnessTensor)
install_mfront_desc(RequireThermalExpansionCoefficientTensor)
install_mfront_desc(SlidingSystem)
install_mfront_desc(SlidingSystems)
install_mfront_desc(SlipSystem)
install_mfront_desc(SlipSystems)
install_mfront_desc(Sources)
install_mfront_desc(SpeedOfSound)
install_mfront_desc(StateVar)
install_mfront_desc(StateVariable)
install_mfront_desc(StaticVar)
install_mfront_desc(StaticVariable)
install_mfront_desc(StrainMeasure)
install_mfront_desc(Swelling)
install_mfront_desc(TangentOperator)
install_mfront_desc(TangentOperatorBlock)
install_mfront_desc(TangentOperatorBlocks)
install_mfront_desc(Theta)
install_mfront_desc(UnitSystem)
install_mfront_desc(UpdateAuxiliaryStateVars)
install_mfront_desc(UpdateAuxiliaryStateVariables)
install_mfront_desc(UsableInPurelyImplicitResolution)
install_mfront_desc(UseQt)

install_mfront_desc2(Implicit HillTensor)

install_mfront_desc2(MaterialLaw Constant)
install_mfront_desc2(MaterialLaw Function)
install_mfront_desc2(MaterialLaw Input)
install_mfront_desc2(MaterialLaw Law)
install_mfront_desc2(MaterialLaw MFront)
install_mfront_desc2(MaterialLaw Output)

install_mfront_desc2(Model ConstantMaterialProperty)
install_mfront_desc2(Model Domain)
install_mfront_desc2(Model Domains)
install_mfront_desc2(Model Function)
install_mfront_desc2(Model Input)
install_mfront_desc2(Model Integrator)
install_mfront_desc2(Model GlobalParameter)
install_mfront_desc2(Model LocalParameter)
install_mfront_desc2(Model Model)
install_mfront_desc2(Model Output)

install_mfront_desc2(bricks StandardElasticity)
install_mfront_desc2(bricks DDIF2)

install_mfront_desc2(stress-potentials Hooke)
install_mfront_desc2(stress-potentials DDIF2)

if(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

  configure_file(glossary.tex.in
    glossary.tex @ONLY)
  add_subdirectory(general)
  add_subdirectory(behaviours)
  add_subdirectory(finitestrain)
  add_subdirectory(planestress)
  add_subdirectory(castem)
  add_subdirectory(aster)
  add_subdirectory(zmat)

endif(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

add_subdirectory(abaqus)
add_subdirectory(ansys)
add_subdirectory(lsdyna)

=== docs/mtest/CMakeLists.txt ===
add_subdirectory(mtest)
add_subdirectory(ptest)

macro(install_mtest_desc file)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${file}.md
      DESTINATION share/doc/mtest-${TFEL_SUFFIX}
      COMPONENT mtest)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${file}.md DESTINATION share/doc/mtest
      COMPONENT mtest)
  endif(TFEL_APPEND_SUFFIX)
endmacro(install_mtest_desc file)

install_mtest_desc(Author)
install_mtest_desc(Behaviour)
install_mtest_desc(CastemAccelerationPeriod)
install_mtest_desc(CastemAccelerationTrigger)
install_mtest_desc(Date)
install_mtest_desc(DynamicTimeStepScaling)
install_mtest_desc(Description)
install_mtest_desc(Evolution)
install_mtest_desc(ExternalStateVariable)
install_mtest_desc(InternalStateVariable)
install_mtest_desc(HandleThermalExpansion)
install_mtest_desc(MaterialProperty)
install_mtest_desc(MaximumNumberOfIterations)
install_mtest_desc(MaximumNumberOfSubSteps)
install_mtest_desc(Message)
install_mtest_desc(Model)
install_mtest_desc(OutputFrequency)
install_mtest_desc(Parameter)
install_mtest_desc(Import)
install_mtest_desc(IntegerParameter)
install_mtest_desc(UnsignedIntegerParameter)
install_mtest_desc(MinimalTimeStep)
install_mtest_desc(MinimalTimeStepScalingFactor)
install_mtest_desc(MaximalTimeStep)
install_mtest_desc(MaximalTimeStepScalingFactor)
install_mtest_desc(OutputFile)
install_mtest_desc(OutputFilePrecision)
install_mtest_desc(Print)
install_mtest_desc(PredictionPolicy)
install_mtest_desc(Real)
install_mtest_desc(ResidualFile)
install_mtest_desc(ResidualFilePrecision)
install_mtest_desc(StiffnessMatrixType)
install_mtest_desc(StiffnessUpdatePolicy)
install_mtest_desc(Times)
install_mtest_desc(UseCastemAccelerationAlgorithm)
install_mtest_desc(OutOfBoundsPolicy)
install_mtest_desc(AccelerationAlgorithm)
install_mtest_desc(AccelerationAlgorithmParameter)
install_mtest_desc(CompareToNumericalTangentOperator)
install_mtest_desc(NumericalTangentOperatorPerturbationValue)

if(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

  configure_file(Champs.tex.in Champs.tex @ONLY)
  configure_file(mtest.tex.in
    mtest.tex @ONLY)
  
  ADD_CUSTOM_COMMAND(
    OUTPUT    mtest.pdf
    DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/Champs.tex.in
    DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/mtest.tex.in
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex/NT
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/images
    ARGS       mtest.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex/NT
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/images
    ARGS       mtest.tex
    COMMAND   BSTINPUTS=@abs_top_srcdir@/docs/tex/texmf/bibtex ${BIBTEX_COMPILER}
    ARGS      -terse mtest
    COMMAND   ${MAKEINDEX_COMPILER}
    ARGS      -s ${CMAKE_CURRENT_SOURCE_DIR}/style.ist mkeys.idx
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex/NT
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/images
    ARGS       mtest.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex/NT
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/images
    ARGS       mtest.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${DVIPS_CONVERTER}
    ARGS      -R0 mtest.dvi
    COMMAND   ${PS2PDF_CONVERTER}
    ARGS      mtest.ps
    COMMENT   "mtest.pdf")
  
  add_custom_target(mtest-doc-pdf ALL DEPENDS mtest.pdf)
  add_dependencies(doc-pdf
    mtest-doc-pdf)

  if(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mtest.pdf
      DESTINATION share/doc/mtest-${TFEL_SUFFIX}
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mtest.pdf
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web/documents/mtest
      COMPONENT website)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mtest.pdf
      DESTINATION share/doc/mtest
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/mtest.pdf
      DESTINATION share/doc/tfel/web/documents/mtest
      COMPONENT website)
  endif(TFEL_APPEND_SUFFIX)
endif(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

=== docs/ptest/CMakeLists.txt ===
if(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

  configure_file(ptest.tex.in
    ptest.tex @ONLY)
  
  ADD_CUSTOM_COMMAND(
    OUTPUT    ptest.pdf
    DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/ptest.tex.in
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${PDFLATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex/NT
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/images
    ARGS       ptest.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${PDFLATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex/NT
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/images
    ARGS       ptest.tex
# COMMAND   BSTINPUTS=@abs_top_srcdir@/docs/tex/texmf/bibtex ${BIBTEX_COMPILER}
# ARGS      -terse ptest
# COMMAND   ${MAKEINDEX_COMPILER}
# ARGS      -s ${CMAKE_CURRENT_SOURCE_DIR}/style.ist mkeys.idx
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${PDFLATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex/NT
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/images
    ARGS       ptest.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${PDFLATEX_COMPILER}
    ARGS      -interaction=batchmode
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex/NT
    ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/images
    ARGS       ptest.tex
    COMMENT   "ptest.pdf")
  
  add_custom_target(ptest-doc-pdf ALL DEPENDS ptest.pdf)
  add_dependencies(doc-pdf
    ptest-doc-pdf)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ptest.pdf
      DESTINATION share/doc/mtest-${TFEL_SUFFIX}/ptest
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ptest.pdf
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web/documents/ptest
      COMPONENT website)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ptest.pdf
      DESTINATION share/doc/mtest/ptest
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/ptest.pdf
      DESTINATION share/doc/tfel/web/documents/ptest
      COMPONENT website)
  endif(TFEL_APPEND_SUFFIX)
endif(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

=== docs/release-notes-3.0/CMakeLists.txt ===
if(HAVE_LATEX)
  configure_file(Champs.tex.in Champs.tex @ONLY)
  configure_file(tfel-3.0.tex.in
    tfel-3.0.tex @ONLY)

  ADD_CUSTOM_COMMAND(
    OUTPUT    tfel-3.0.pdf
    DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/Champs.tex.in
    DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/tfel-3.0.tex.in
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode tfel-3.0.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode tfel-3.0.tex
    # COMMAND   BSTINPUTS=@abs_top_srcdir@/docs/tex/texmf/bibtex ${BIBTEX_COMPILER}
    # ARGS      -terse tfel-3.0
    # COMMAND   ${MAKEINDEX_COMPILER}
    # ARGS      -s ${CMAKE_CURRENT_SOURCE_DIR}/style.ist mkeys.idx
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode tfel-3.0.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode tfel-3.0.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${DVIPS_CONVERTER}
    ARGS      -R0 tfel-3.0.dvi
    COMMAND   ${PS2PDF_CONVERTER}
    ARGS      tfel-3.0.ps
    COMMENT   "tfel-3.0.pdf")

  add_custom_target(tfel-3.0-doc-pdf ALL DEPENDS tfel-3.0.pdf)
  add_dependencies(doc-pdf
    tfel-3.0-doc-pdf)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-3.0.pdf
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/references
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-3.0.pdf
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web/documents/tfel/tfel
      COMPONENT website)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-3.0.pdf
      DESTINATION share/doc/tfel/references
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/tfel-3.0.pdf
      DESTINATION share/doc/tfel/web/documents/tfel/tfel
      COMPONENT website)
  endif(TFEL_APPEND_SUFFIX)
endif(HAVE_LATEX)

=== docs/tfel/CMakeLists.txt ===
if(HAVE_LATEX)
  configure_file(Champs.tex.in Champs.tex @ONLY)
  configure_file(reference-guide.tex.in
    reference-guide.tex @ONLY)

  ADD_CUSTOM_COMMAND(
    OUTPUT    reference-guide.pdf
    DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/Champs.tex.in
    DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/reference-guide.tex.in
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode reference-guide.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode reference-guide.tex
    COMMAND   BSTINPUTS=@abs_top_srcdir@/docs/tex/texmf/bibtex ${BIBTEX_COMPILER}
    ARGS      -terse reference-guide
    COMMAND   ${MAKEINDEX_COMPILER}
    ARGS      -s ${CMAKE_CURRENT_SOURCE_DIR}/style.ist tclass.idx
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${LATEX_COMPILER}
    ARGS      -interaction=batchmode reference-guide.tex
    COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${DVIPS_CONVERTER}
    ARGS      -R0 reference-guide.dvi
    COMMAND   ${PS2PDF_CONVERTER}
    ARGS      reference-guide.ps
    COMMENT   "reference-guide.pdf")
  
  # Eventually trigger the whole process
  add_custom_target(tfel-doc-pdf ALL DEPENDS reference-guide.pdf)
  add_dependencies(doc-pdf
    tfel-doc-pdf)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/reference-guide.pdf
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/reference-guide.pdf
      DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web/documents/tfel
      COMPONENT website)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/reference-guide.pdf
      DESTINATION share/doc/tfel
      COMPONENT docs)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/reference-guide.pdf
      DESTINATION share/doc/tfel/web/documents/tfel
      COMPONENT website)
  endif(TFEL_APPEND_SUFFIX)
endif(HAVE_LATEX)

=== docs/tutorial/CMakeLists.txt ===
if(HAVE_LATEX)
  macro(pdflatex_tutorial doc)
    configure_file(${doc}.tex.in ${doc}.tex @ONLY)
    ADD_CUSTOM_COMMAND(
      OUTPUT    ${doc}.pdf
      DEPENDS    ${CMAKE_CURRENT_SOURCE_DIR}/${doc}.tex.in
      COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${PDFLATEX_COMPILER}
      ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex
      ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex/NT
      ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/images
      ARGS      --include-directory=@abs_top_srcdir@/docs/tutorial
      ARGS      -interaction=batchmode ${doc}.tex
      COMMAND   BSTINPUTS=@abs_top_srcdir@/docs/tex/texmf/bibtex ${BIBTEX_COMPILER}
      ARGS      -terse ${doc}
      COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${PDFLATEX_COMPILER}
      ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex
      ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex/NT
      ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/images
      ARGS      --include-directory=@abs_top_srcdir@/docs/tutorial
      ARGS      -interaction=batchmode ${doc}.tex
      ${doc}.tex
      COMMAND   TEXMFHOME=@abs_top_srcdir@/docs/tex/texmf        ${PDFLATEX_COMPILER}
      ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex
      ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/latex/NT
      ARGS      --include-directory=@abs_top_srcdir@/docs/tex/texmf/tex/images
      ARGS      --include-directory=@abs_top_srcdir@/docs/tutorial
      ARGS      -interaction=batchmode ${doc}.tex
      ${doc}.tex
      COMMENT   "${doc}.pdf")
    add_custom_target(${doc}-doc-pdf ALL DEPENDS ${doc}.pdf)
    add_dependencies(doc-pdf
      ${doc}-doc-pdf)
    if(TFEL_APPEND_SUFFIX)
      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${doc}.pdf
	DESTINATION share/doc/mfront-${TFEL_SUFFIX}/${doc}
	COMPONENT docs)
      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${doc}.pdf
	DESTINATION share/doc/tfel-${TFEL_SUFFIX}/web/documents/${doc}
	COMPONENT website)
    else(TFEL_APPEND_SUFFIX)
      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${doc}.pdf
	DESTINATION share/doc/mfront/${doc}
	COMPONENT docs)
      install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${doc}.pdf
	DESTINATION share/doc/tfel/web/documents/${doc}
	COMPONENT website)
    endif(TFEL_APPEND_SUFFIX)
  endmacro(pdflatex_tutorial doc)

  configure_file(Bibliographie.tex.in
    Bibliographie.tex @ONLY)
  configure_file(introduction.tex.in
    introduction.tex @ONLY)
  configure_file(tutoriel.tex.in
    tutoriel.tex @ONLY)	
  configure_file(Chaboche.tex.in
    Chaboche.tex @ONLY)	
  configure_file(rappels.tex.in
    rappels.tex @ONLY)	
  configure_file(Conclusions.tex.in
    Conclusions.tex @ONLY)
  configure_file(resume.tex.in
    resume.tex @ONLY)	
  configure_file(ViscoCompressible.tex.in
    ViscoCompressible.tex @ONLY)

  pdflatex_tutorial(tutoriel)
endif(HAVE_LATEX)

=== mfm-test-generator/src/CMakeLists.txt ===
macro(mfmtg_library name)
  tfel_library_internal(${name} mfm ${ARGN})
endmacro(mfmtg_library)

mfmtg_library(MFMTestGenerator
  Log.cxx
  BehaviourData.cxx
  AbstractTestCase.cxx
  TestCaseBase.cxx
  AbstractTestCaseFactory.cxx
  InputFileGeneratorFactory.cxx
  TestCaseParameters.cxx
  UniaxialTensileTest.cxx
  ClosedPipeTest.cxx
  MTestInputFileGenerators.cxx
  LicosInputFileGenerators.cxx
  MFMTestGeneratorFileExport.cxx)
target_include_directories(MFMTestGenerator
   PUBLIC 
   $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/include>
   $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/mfront/include>
   $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/mfront/include>
   $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/mfm-test-generator/include>
   $<INSTALL_INTERFACE:include>)
target_link_libraries(MFMTestGenerator
  PUBLIC
  MFrontLogStream
  TFELMTest TFELMaterial
  TFELSystem TFELUtilities)

if(TFEL_HAVE_MADNEX)
  target_compile_definitions(MFMTestGenerator
    PUBLIC MFM_TEST_GENERATOR_HAVE_MADNEX)
  target_link_libraries(MFMTestGenerator
    PUBLIC madnex::Madnex)
endif(TFEL_HAVE_MADNEX)

add_executable(mfm-test-generator mfm-test-generator.cxx)
target_link_libraries(mfm-test-generator
 PRIVATE
 MFMTestGenerator)
if(TFEL_APPEND_SUFFIX)
  set_target_properties(mfm-test-generator
    PROPERTIES OUTPUT_NAME "mfm-test-generator-${TFEL_SUFFIX}")
endif(TFEL_APPEND_SUFFIX)
install(TARGETS mfm-test-generator DESTINATION bin COMPONENT mfm)

=== mfm/src/CMakeLists.txt ===
add_executable(mfm mfm.cxx)
target_link_libraries(mfm
  TFELSystem TFELUtilities)
if(TFEL_APPEND_SUFFIX)
  set_target_properties(mfm
    PROPERTIES OUTPUT_NAME "mfm-${TFEL_SUFFIX}")
endif(TFEL_APPEND_SUFFIX)
install(TARGETS mfm DESTINATION bin COMPONENT mfm)

=== PKGBUILD ===
# Maintainer: Rafał Brzegowy <rafal.brzegowy@yahoo.com>

_realname=tfel
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=4.2.0
pkgrel=2
pkgdesc='MFront: a code generation tool dedicated to material knowledge (mingw-w64)'
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
provides=("${MINGW_PACKAGE_PREFIX}-mfront")
depends=("${MINGW_PACKAGE_PREFIX}-gnuplot"
         $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-libgfortran") )
makedepends=("unzip"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-cc"
             $([[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]] || echo "${MINGW_PACKAGE_PREFIX}-gcc-fortran") )
license=('GPL')
url='https://tfel.sourceforge.io/'
source=(https://github.com/thelfer/${_realname}/archive/TFEL-${pkgver}.zip)
sha256sums=('F4B8285E7AABB26DA9AFEEF1DB59BCB7E596BA8F3FA851F2610C08803ED5D1B6')
noextract=("TFEL-${pkgver}.zip") # bsdtar could not unpack this archive

prepare() {
  unzip -oq TFEL-${pkgver}.zip -d ${srcdir}
}

build() {
  [[ -d "${srcdir}/build-${MSYSTEM}" ]] && rm -rf "${srcdir}/build-${MSYSTEM}"
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_conf
  case ${MSYSTEM} in
    CLANG*)
      extra_conf+=("-Denable-fortran=OFF");;
    *)
      extra_conf+=("-Denable-fortran=ON");;
  esac

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_BUILD_TYPE=Release \
      -Denable-python=OFF \
      -Denable-python-bindings=OFF \
      -Denable-aster=ON \
      -Denable-abaqus=ON \
      -Denable-ansys=ON \
      -Denable-europlexus=ON \
      -Denable-zmat=ON \
      -Denable-cyrano=ON \
      -Denable-calculix=ON \
      -Denable-comsol=ON \
      -Denable-diana-fea=ON \
      -Denable-lsdyna=ON \
      -Denable-cxx-17=ON \
      -Denable-portable-build=ON \
      -Denable-reference-doc=OFF \
      ${extra_conf} \
      ../${_realname}-TFEL-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"
  DESTDIR=${pkgdir} cmake --build . --target install
  install -Dm644 ${srcdir}/${_realname}-TFEL-${pkgver}/LICENCE-GNU-GPL ${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}

# vim: ts=2 sw=2 et:
